/* $Id: imutils.c,v 1.2 2000/02/02 16:42:39 flitney Exp $ */
#include "avwimage.h"
#include "imutils.h"
#include <stdlib.h>

void cor2ax(void *ox, void *oy, void *oz, 
	    void *nx, void *ny, void *nz,
	    size_t nbytes)
{
  memcpy(nx, ox, nbytes);
  memcpy(ny, oz, nbytes);
  memcpy(nz, oy, nbytes);
  /*  *nx = ox; *ny = oz; *nz = oy; */
} 

void sag2ax(void *ox, void *oy, void *oz, 
	    void *nx, void *ny, void *nz,
	    size_t nbytes)
{
  memcpy(nx, oz, nbytes);
  memcpy(ny, ox, nbytes);
  memcpy(nz, oy, nbytes);
  /*  *nx = oz; *ny = ox; *nz = oy; */
} 

void ax2sag(void *ox, void *oy, void *oz, 
	    void *nx, void *ny, void *nz,
	    size_t nbytes)
{
  memcpy(nx, oy, nbytes);
  memcpy(ny, oz, nbytes);
  memcpy(nz, ox, nbytes);
  /*  *nx = oy; *ny = oz; *nz = ox; */
} 

void ax2cor(void *ox, void *oy, void *oz, 
	    void *nx, void *ny, void *nz,
	    size_t nbytes)
{
  memcpy(nx, ox, nbytes);
  memcpy(ny, oz, nbytes);
  memcpy(nz, oy, nbytes);
  /*  *nx = ox; *ny = oz; *nz = oy; */
}

void reorder(AVWImage *im, void swap(void *, void *, void *, 
				     void *, void *, void *,
				     size_t nbytes))
{
  short x, y, z, v;
  short nxdim, nydim, nzdim;
  float nxvox, nyvox, nzvox;
  void *dest = NULL;

  if((dest = (void *) calloc(im->xdim * im->ydim * im->zdim * im->vdim, 
			     im->bpv)) == NULL)
    { perror("ReadAvw"); exit(-1); }

  swap(&im->xdim, &im->ydim, &im->zdim, &nxdim, &nydim, &nzdim, sizeof(short));
  swap(&im->xvox, &im->yvox, &im->zvox, &nxvox, &nyvox, &nzvox, sizeof(float));
 
  for(v = 0; v < im->vdim; v++)
    {
      size_t voffset;

      voffset = v  * im->zdim * im->ydim * im->xdim;

      for(z = 0; z < im->zdim; z++)
	for(y = 0; y < im->ydim; y++)
	  for(x = 0; x < im->xdim; x++)
	    {
	      short nx, ny, nz;
	      size_t destoff, dataoff;

	      swap(&x, &y, &z, &nx, &ny, &nz, sizeof(short));
	      dataoff = ( voffset 
			  + (z  * im->ydim * im->xdim) 
			  + (y  * im->xdim) 
			  +  x) * im->bpv;
	      destoff = ( voffset
			  + (nz  * nydim * nxdim)
			  + (ny  * nxdim)
			  +  nx) * im->bpv;
	      memcpy((char *)dest + destoff, 
		     (char *)im->data + dataoff, 
		     im->bpv);
	    }
    }
  im->xdim = nxdim;
  im->ydim = nydim;
  im->zdim = nzdim;
  im->xvox = nxvox;
  im->yvox = nyvox;
  im->zvox = nzvox;

  free(im->data);
  im->data = dest;
}      
