
set USER     $env(USER)
set HOME     [ exec sh -c " cd ; pwd " ]
set PWD      [ exec sh -c " pwd " ]
set PROCID   [ pid ]
set HOSTNAME [ exec hostname ]
set OS       [ exec uname ]

# are we running inside MEDx?
if { ! [ info exists INMEDX ] } {

    set INMEDX 1
    set PXHOME $env(PXHOME)

    # kludge to tell whether we are in version 3.20 or 3.30
    if { [ file exists ${PXHOME}/ui/dialogs/talairachdaemon.tcl ] } {
	set MEDXV 3.3
    } else {
	set MEDXV 3.2
    }

    set auto_path [ linsert $auto_path 0 $PXHOME/ui $PXHOME/ui/tix ]
    set bitmapdir $PXHOME/ui/bitmaps
    set Message(freeze) ""

} else {

    # make sure that we aren't using any MEDx stuff
    set PXHOME /grotgrot
    
}

# set FSLDIR from environment, or, failing that, PXHOME
if { [ info exists env(FSLDIR) ] } {
    set FSLDIR $env(FSLDIR)
} else {
    set FSLDIR $PXHOME/fsl
    set env(FSLDIR) $FSLDIR
}
set auto_path [ linsert $auto_path 0 $FSLDIR/tcl ]

# for running outside of FMRIB don't try to renice
if { [ file exists /usr/local/bin/nicemedx ] } {
    set RENICE 1
} else {
    set RENICE 0
}

# are we on the FMRIB cluster?
set CLUSTERRSH ""
if { $HOSTNAME == "cayenne0.fmrib.ox.ac.uk" } {
    set CLUSTERRSH " rsh crunch "
}

source $FSLDIR/tcl/FSLFileDirBox.tcl
source $FSLDIR/tcl/FSLFileDirDlg.tcl
source $FSLDIR/tcl/FSLFileEntry.tcl

